#pragma once
#include "communication/bridge/proxy/i_bridge_proxy.h"
#include "communication/bridge/connection_lifecycle/i_connection_factory.h"
#include <kr2_program_api/api_v1/program_interface.h>

namespace spin
{
    class IBridgeProxyFactory
    {
    public:
        virtual ~IBridgeProxyFactory() = default;
        virtual std::shared_ptr<IBridgeProxy> createProxy(std::shared_ptr<IConnectionFactory> connectionFactory, boost::shared_ptr<kr2_program_api::ProgramInterface> api) = 0;
        virtual std::shared_ptr<IBridgeProxy> createProxy() = 0;
    };
} // namespace spin
