#pragma once
#include <iostream>
#include <sstream>

namespace spin
{
    struct MonitoredItems
    {
        MonitoredItems(const bool heartbeat,
                       const bool freedriveButtonPushed,
                       const bool frontButtonPushed,
                       const bool toolConnected,
                       const std::string &latestResultUUID,
                       const int programDataReadyID)
        {
            heartbeat_ = heartbeat;
            freedriveButtonPushed_ = freedriveButtonPushed;
            frontButtonPushed_ = frontButtonPushed;
            toolConnected_ = toolConnected;
            latestResultUUID_ = latestResultUUID;
            programDataReadyID_ = programDataReadyID;
        }

        virtual ~MonitoredItems() = default;

        inline friend std::ostream &operator<<(std::ostream &out, const MonitoredItems &monitoredItems)
        {
            out << "heartbeat: " << monitoredItems.heartbeat_ << std::endl;
            out << "freedriveButtonPushed: " << monitoredItems.freedriveButtonPushed_ << std::endl;
            out << "frontButtonPushed: " << monitoredItems.frontButtonPushed_ << std::endl;
            out << "toolConnected: " << monitoredItems.toolConnected_ << std::endl;
            out << "latestResultUUID: " << monitoredItems.latestResultUUID_ << std::endl;
            out << "programDataReadyID: " << monitoredItems.programDataReadyID_ << std::endl;
            return out;
        }

        std::string toString() const
        {
            std::ostringstream oss;
            oss << *this;
            return oss.str();
        }

        inline bool operator==(const MonitoredItems &rhs) const
        {
            return heartbeat_ == rhs.heartbeat_ &&
                   freedriveButtonPushed_ == rhs.freedriveButtonPushed_ &&
                   frontButtonPushed_ == rhs.frontButtonPushed_ &&
                   toolConnected_ == rhs.toolConnected_ &&
                   latestResultUUID_ == rhs.latestResultUUID_ &&
                   programDataReadyID_ == rhs.programDataReadyID_;
        }

        bool heartbeat_;
        bool freedriveButtonPushed_;
        bool frontButtonPushed_;
        bool toolConnected_;
        std::string latestResultUUID_;
        int programDataReadyID_;
    };
}